#ifndef __CSV_H__
#define __CSV_H__ 1

typedef struct M_csv_data {
        char ***data_arr;
        int num_rows;
        int num_cols;
        char *data_ptr;
} M_csv_data;

void M_csv_free(M_csv_data *data);
M_csv_data *M_csv_parse(const char *str, size_t len, char delim, char quote);
M_csv_data *M_csv_parse_inplace(char *data, size_t len, char delim, char quote);

/* Raw getters if no headers used */
#define M_csv_raw_num_rows(csv) ((csv)->num_rows)
#define M_csv_raw_num_cols(csv) ((csv)->num_cols)
#define M_csv_raw_cell(csv, row, col) (((csv)->num_rows > row && (csv)->num_cols > col)?(csv)->data_arr[row][col]:NULL)

/* getters if headers used (default) */
#define M_csv_get_numcols(csv) M_csv_raw_num_cols(csv)
#define M_csv_get_numrows(csv) (M_csv_raw_num_rows(csv)-1)
#define M_csv_get_cellbynum(csv, row, col) M_csv_raw_cell(csv, row+1, col)
#define M_csv_get_header(csv, col) M_csv_raw_cell(csv, 0, col)
const char *M_csv_get_cell(M_csv_data *csv, int row, const char *colname);

#endif
