#ifndef __SNPRINTF_H__
#define __SNPRINTF_H__

#include <stdarg.h>
#ifndef _WIN32
#    include <sys/ioctl.h>
#    include <sys/param.h>
#endif
#include "monetra.h"

#ifndef __printflike
#ifdef __GNUC__
#define __printflike(fmtarg, firstvararg) \
        __attribute__((__format__ (__printf__, fmtarg, firstvararg)))
#else
#define __printflike(fmtarg, firstvararg)
#endif
#endif

/* SNPRINTF REPLACEMENT CALLS */
int M_snprintf(char *str, size_t count, const char *fmt,...) __printflike(3, 4);
int M_vsnprintf(char *str, size_t count, const char *fmt, va_list args);
int M_vasprintf(char **ret, const char *fmt, va_list args);
int M_asprintf(char **ret, const char *fmt, ...) __printflike(2, 3);
int M_vfprintf(FILE *fp, const char *fmt, va_list args);
int M_fprintf(FILE *fp, const char *fmt, ...) __printflike(2, 3);
int M_vdprintf(int fd, const char *fmt, va_list args);
int M_dprintf(int fd, const char *fmt, ...) __printflike(2, 3);
int M_vprintf(const char *fmt, va_list args);
int M_printf(const char *fmt, ...) __printflike(1, 2);

#endif
